Index: main/manager.c
===================================================================
--- main/manager.c	(revision 148468)
+++ main/manager.c	(working copy)
@@ -2850,32 +2983,37 @@
 	const char *module = astman_get_header(m, "Module");
 	const char *loadtype = astman_get_header(m, "LoadType");
 
-	if (!loadtype || strlen(loadtype) == 0)
+	if (!loadtype || strlen(loadtype) == 0) {
 		astman_send_error(s, m, "Incomplete ModuleLoad action.");
-	if ((!module || strlen(module) == 0) && strcasecmp(loadtype, "reload") != 0)
+	}
+	if ((!module || strlen(module) == 0) && strcasecmp(loadtype, "reload") != 0) {
 		astman_send_error(s, m, "Need module name");
+	}
 
 	if (!strcasecmp(loadtype, "load")) {
 		res = ast_load_resource(module);
-		if (res)
+		if (res) {
 			astman_send_error(s, m, "Could not load module.");
-		else
+		} else {
 			astman_send_ack(s, m, "Module loaded.");
+		}
 	} else if (!strcasecmp(loadtype, "unload")) {
 		res = ast_unload_resource(module, AST_FORCE_SOFT);
-		if (res)
+		if (res) {
 			astman_send_error(s, m, "Could not unload module.");
-		else
+		} else {
 			astman_send_ack(s, m, "Module unloaded.");
+		}
 	} else if (!strcasecmp(loadtype, "reload")) {
 		if (module != NULL) {
 			res = ast_module_reload(module);
-			if (res == 0)
+			if (res == 0) {
 				astman_send_error(s, m, "No such module.");
-			else if (res == 1)
+			} else if (res == 1) {
 				astman_send_error(s, m, "Module does not support reload action.");
-			else
+			} else {
 				astman_send_ack(s, m, "Module reloaded.");
+			}
 		} else {
 			ast_module_reload(NULL);	/* Reload all modules */
 			astman_send_ack(s, m, "All modules reloaded");
@@ -2904,21 +3042,22 @@
 	int ret = 0;
 	struct manager_action *tmp;
 	const char *user = astman_get_header(m, "Username");
+	int (*call_func)(struct mansession *s, const struct message *m) = NULL;
 
 	ast_copy_string(action, __astman_get_header(m, "Action", GET_HEADER_SKIP_EMPTY), sizeof(action));
 	ast_debug(1, "Manager received command '%s'\n", action);
 
 	if (ast_strlen_zero(action)) {
-		ast_mutex_lock(&s->__lock);
+		ao2_lock(s);
 		astman_send_error(s, m, "Missing action in request");
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 		return 0;
 	}
 
 	if (!s->authenticated && strcasecmp(action, "Login") && strcasecmp(action, "Logoff") && strcasecmp(action, "Challenge")) {
-		ast_mutex_lock(&s->__lock);
+		ao2_lock(s);
 		astman_send_error(s, m, "Permission denied");
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 		return 0;
 	}
 
@@ -2926,34 +3065,40 @@
 		(!strcasecmp(action, "Login") || !strcasecmp(action, "Challenge"))) {
 		if (check_manager_session_inuse(user)) {
 			sleep(1);
-			ast_mutex_lock(&s->__lock);
+			ao2_lock(s);
 			astman_send_error(s, m, "Login Already In Use");
-			ast_mutex_unlock(&s->__lock);
+			ao2_unlock(s);
 			return -1;
 		}
 	}
 
 	AST_RWLIST_RDLOCK(&actions);
 	AST_RWLIST_TRAVERSE(&actions, tmp, list) {
-		if (strcasecmp(action, tmp->action))
+		if (strcasecmp(action, tmp->action)) {
 			continue;
-		if (s->writeperm & tmp->authority || tmp->authority == 0)
-			ret = tmp->func(s, m);
-		else
+		}
+		if (s->writeperm & tmp->authority || tmp->authority == 0) {
+			call_func = tmp->func;
+		} else {
 			astman_send_error(s, m, "Permission denied");
+		}
 		break;
 	}
 	AST_RWLIST_UNLOCK(&actions);
 
-	if (!tmp) {
+	if (tmp) {
+		/* call AMI function after actions list are unlocked */
+		ret = call_func(s, m);
+	} else {
 		char buf[512];
 		snprintf(buf, sizeof(buf), "Invalid/unknown command: %s. Use Action: ListCommands to show available commands.", action);
-		ast_mutex_lock(&s->__lock);
+		ao2_lock(s);
 		astman_send_error(s, m, buf);
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 	}
-	if (ret)
+	if (ret) {
 		return ret;
+	}
 	/* Once done with our message, deliver any pending events */
 	return process_events(s);
 }
@@ -2979,12 +3124,13 @@
 	 */
 	for (x = 0; x < s->inlen; x++) {
 		int cr;	/* set if we have \r */
-		if (src[x] == '\r' && x+1 < s->inlen && src[x+1] == '\n')
+		if (src[x] == '\r' && x+1 < s->inlen && src[x+1] == '\n') {
 			cr = 2;	/* Found. Update length to include \r\n */
-		else if (src[x] == '\n')
+		} else if (src[x] == '\n') {
 			cr = 1;	/* also accept \n only */
-		else
+		} else {
 			continue;
+		}
 		memmove(output, src, x);	/*... but trim \r\n */
 		output[x] = '\0';		/* terminate the string */
 		x += cr;			/* number of bytes used */
@@ -3000,40 +3146,42 @@
 	res = 0;
 	while (res == 0) {
 		/* XXX do we really need this locking ? */
-		ast_mutex_lock(&s->__lock);
+		ao2_lock(s);
 		if (s->pending_event) {
 			s->pending_event = 0;
-			ast_mutex_unlock(&s->__lock);
+			ao2_unlock(s);
 			return 0;
 		}
 		s->waiting_thread = pthread_self();
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 
 		res = ast_wait_for_input(s->fd, -1);	/* return 0 on timeout ? */
 
-		ast_mutex_lock(&s->__lock);
+		ao2_lock(s);
 		s->waiting_thread = AST_PTHREADT_NULL;
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
 	}
 	if (res < 0) {
 		/* If we get a signal from some other thread (typically because
 		 * there are new events queued), return 0 to notify the caller.
 		 */
-		if (errno == EINTR || errno == EAGAIN)
+		if (errno == EINTR || errno == EAGAIN) {
 			return 0;
+		}
 		ast_log(LOG_WARNING, "poll() returned error: %s\n", strerror(errno));
 		return -1;
 	}
-	ast_mutex_lock(&s->__lock);
+
+	ao2_lock(s);
 	res = fread(src + s->inlen, 1, maxlen - s->inlen, s->f);
-	if (res < 1)
+	if (res < 1) {
 		res = -1;	/* error return */
-	else {
+	} else {
 		s->inlen += res;
 		src[s->inlen] = '\0';
 		res = 0;
 	}
-	ast_mutex_unlock(&s->__lock);
+	ao2_unlock(s);
 	return res;
 }
 
@@ -3045,16 +3193,18 @@
 
 	for (;;) {
 		/* Check if any events are pending and do them if needed */
-		if (process_events(s))
+		if (process_events(s)) {
 			return -1;
+		}
 		res = get_input(s, header_buf);
 		if (res == 0) {
 			continue;
 		} else if (res > 0) {
-			if (ast_strlen_zero(header_buf))
+			if (ast_strlen_zero(header_buf)) {
 				return process_message(s, &m) ? -1 : 0;
-			else if (m.hdrcount < (AST_MAX_MANHEADERS - 1))
+			} else if (m.hdrcount < (AST_MAX_MANHEADERS - 1)) {
 				m.headers[m.hdrcount++] = ast_strdupa(header_buf);
+			}
 		} else {
 			return res;
 		}
@@ -3072,25 +3222,23 @@
 static void *session_do(void *data)
 {
 	struct ast_tcptls_session_instance *ser = data;
-	struct mansession *s = ast_calloc(1, sizeof(*s));
+	struct mansession *s = build_mansession(ser->requestor);
 	int flags;
 	int res;
 
-	if (s == NULL)
+	if (s == NULL) {
 		goto done;
+	}
+	ao2_lock(sessions);
 
-	s->writetimeout = 100;
-	s->waiting_thread = AST_PTHREADT_NULL;
-
 	flags = fcntl(ser->fd, F_GETFL);
-	if (!block_sockets) /* make sure socket is non-blocking */
+	if (!block_sockets) { /* make sure socket is non-blocking */
 		flags |= O_NONBLOCK;
-	else
+	} else {
 		flags &= ~O_NONBLOCK;
+	}
 	fcntl(ser->fd, F_SETFL, flags);
 
-	ast_mutex_init(&s->__lock);
-	s->send_events = -1;
 	/* Hook to the tail of the event queue */
 	s->last_ev = grab_last();
 
@@ -3101,24 +3249,23 @@
 
 	AST_LIST_HEAD_INIT_NOLOCK(&s->datastores);
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_INSERT_HEAD(&sessions, s, list);
-	ast_atomic_fetchadd_int(&num_sessions, 1);
-	AST_LIST_UNLOCK(&sessions);
-
+	ao2_unlock(sessions);
 	astman_append(s, "Asterisk Call Manager/%s\r\n", AMI_VERSION);	/* welcome prompt */
 	for (;;) {
-		if ((res = do_message(s)) < 0)
+		if ((res = do_message(s)) < 0) {
 			break;
+		}
 	}
 	/* session is over, explain why and terminate */
 	if (s->authenticated) {
-			if (manager_displayconnects(s))
+		if (manager_displayconnects(s)) {
 			ast_verb(2, "Manager '%s' logged off from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
+		}
 		ast_log(LOG_EVENT, "Manager '%s' logged off from %s\n", s->username, ast_inet_ntoa(s->sin.sin_addr));
 	} else {
-			if (displayconnects)
+		if (displayconnects) {
 			ast_verb(2, "Connect attempt from '%s' unable to authenticate\n", ast_inet_ntoa(s->sin.sin_addr));
+		}
 		ast_log(LOG_EVENT, "Failed attempt from %s\n", ast_inet_ntoa(s->sin.sin_addr));
 	}
 
@@ -3135,7 +3282,7 @@
 	*/
 	usleep(1);
 
-	destroy_session(s);
+	session_destroy(s);
 
 done:
 	ao2_ref(ser, -1);
@@ -3148,23 +3295,24 @@
 {
 	struct mansession *s;
 	time_t now = time(NULL);
+	struct ao2_iterator i;
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE_SAFE_BEGIN(&sessions, s, list) {
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i)) && n_max > 0) {
+		unref_mansession(s);
+		ao2_lock(s);
 		if (s->sessiontimeout && (now > s->sessiontimeout) && !s->inuse) {
-			AST_LIST_REMOVE_CURRENT(list);
-			ast_atomic_fetchadd_int(&num_sessions, -1);
 			if (s->authenticated && (VERBOSITY_ATLEAST(2)) && manager_displayconnects(s)) {
 				ast_verb(2, "HTTP Manager '%s' timed out from %s\n",
 					s->username, ast_inet_ntoa(s->sin.sin_addr));
 			}
-			free_session(s);	/* XXX outside ? */
-			if (--n_max <= 0)
-				break;
+			ao2_unlock(s);
+			session_destroy(s);
+			n_max--;
+		} else {
+			ao2_unlock(s);
 		}
 	}
-	AST_LIST_TRAVERSE_SAFE_END;
-	AST_LIST_UNLOCK(&sessions);
 }
 
 /*
@@ -3176,8 +3324,9 @@
 	struct eventqent *tmp = ast_malloc(sizeof(*tmp) + strlen(str));
 	static int seq;	/* sequence number */
 
-	if (!tmp)
+	if (!tmp) {
 		return -1;
+	}
 
 	/* need to init all fields, because ast_malloc() does not */
 	tmp->usecount = 0;
@@ -3208,13 +3357,16 @@
 	va_list ap;
 	struct timeval now;
 	struct ast_str *buf;
+	struct ao2_iterator i;
 
 	/* Abort if there aren't any manager sessions */
-	if (!num_sessions)
+	if (!num_sessions) {
 		return 0;
+	}
 
-	if (!(buf = ast_str_thread_get(&manager_event_buf, MANAGER_EVENT_BUF_INITSIZE)))
+	if (!(buf = ast_str_thread_get(&manager_event_buf, MANAGER_EVENT_BUF_INITSIZE))) {
 		return -1;
+	}
 
 	cat_str = authority_to_str(category, &auth);
 	ast_str_set(&buf, 0,
@@ -3245,21 +3397,22 @@
 	append_event(buf->str, category);
 
 	/* Wake up any sleeping sessions */
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, s, list) {
-		ast_mutex_lock(&s->__lock);
-		if (s->waiting_thread != AST_PTHREADT_NULL)
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
+		if (s->waiting_thread != AST_PTHREADT_NULL) {
 			pthread_kill(s->waiting_thread, SIGURG);
-		else
+		} else {
 			/* We have an event to process, but the mansession is
 			 * not waiting for it. We still need to indicate that there
 			 * is an event waiting so that get_input processes the pending
 			 * event instead of polling.
 			 */
 			s->pending_event = 1;
-		ast_mutex_unlock(&s->__lock);
+		}
+		ao2_unlock(s);
+		unref_mansession(s);
 	}
-	AST_LIST_UNLOCK(&sessions);
 
 	AST_RWLIST_RDLOCK(&manager_hooks);
 	AST_RWLIST_TRAVERSE(&manager_hooks, hook, list) {
@@ -3320,10 +3473,11 @@
 		}
 	}
 	
-	if (prev)	
+	if (prev) {
 		AST_RWLIST_INSERT_AFTER(&actions, prev, act, list);
-	else
+	} else {
 		AST_RWLIST_INSERT_HEAD(&actions, act, list);
+	}
 
 	ast_verb(2, "Manager registered action %s\n", act->action);
 
@@ -3338,8 +3492,9 @@
 {
 	struct manager_action *cur = NULL;
 
-	if (!(cur = ast_calloc(1, sizeof(*cur))))
+	if (!(cur = ast_calloc(1, sizeof(*cur)))) {
 		return -1;
+	}
 
 	cur->action = action;
 	cur->authority = auth;
@@ -3386,24 +3541,63 @@
 static struct mansession *find_session(uint32_t ident, int incinuse)
 {
 	struct mansession *s;
+	struct ao2_iterator i;
 
-	if (ident == 0)
+	if (ident == 0) {
 		return NULL;
+	}
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, s, list) {
-		ast_mutex_lock(&s->__lock);
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
 		if (s->managerid == ident && !s->needdestroy) {
 			ast_atomic_fetchadd_int(&s->inuse, incinuse ? 1 : 0);
+			unref_mansession(s);
 			break;
 		}
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
+		unref_mansession(s);
 	}
-	AST_LIST_UNLOCK(&sessions);
 
 	return s;
 }
 
+/*!
+ * locate an http session in the list.
+ * The search keys (nonce) and (username) is value from received 
+ * "Authorization" http header.
+ * As well as in find_session() function, the value of the nonce can't be zero.
+ * (0 meansi, that the session used for AMI socket connection).
+ * Flag (stale) is set, if client used valid, but old, nonce value.
+ * 
+ */
+static struct mansession *find_session_by_nonce(const char *username, unsigned long nonce, int *stale)
+{
+	struct mansession *s;
+	struct ao2_iterator i;
+
+	if (nonce == 0 || username == NULL || stale == NULL) {
+		return NULL;
+	}
+	
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
+		if (!strcasecmp(s->username, username) && s->managerid == nonce) {
+			*stale = 0;
+			unref_mansession(s);
+			break;
+		} else if (!strcasecmp(s->username, username) && s->oldnonce == nonce) {
+			*stale = 1;
+			unref_mansession(s);
+			break;
+		}
+		ao2_unlock(s);
+		unref_mansession(s);
+	}
+	return s;
+}
+
 int astman_is_authed(uint32_t ident) 
 {
 	int authed;
@@ -3414,7 +3608,7 @@
 
 	authed = (s->authenticated != 0);
 
-	ast_mutex_unlock(&s->__lock);
+	ao2_unlock(s);
 
 	return authed;
 }
@@ -3423,18 +3617,24 @@
 {
 	int result = 0;
 	struct mansession *s;
+	struct ao2_iterator i;
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, s, list) {
-		ast_mutex_lock(&s->__lock);
+	if (ident == 0) {
+		return 0;
+	}
+
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
 		if ((s->managerid == ident) && (s->readperm & perm)) {
 			result = 1;
-			ast_mutex_unlock(&s->__lock);
+			ao2_unlock(s);
+			unref_mansession(s);
 			break;
 		}
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
+		unref_mansession(s);
 	}
-	AST_LIST_UNLOCK(&sessions);
 	return result;
 }
 
@@ -3442,18 +3642,24 @@
 {
 	int result = 0;
 	struct mansession *s;
+	struct ao2_iterator i;
 
-	AST_LIST_LOCK(&sessions);
-	AST_LIST_TRAVERSE(&sessions, s, list) {
-		ast_mutex_lock(&s->__lock);
+	if (ident == 0) {
+		return 0;
+	}
+
+	i = ao2_iterator_init(sessions, 0);
+	while ((s = ao2_iterator_next(&i))) {
+		ao2_lock(s);
 		if ((s->managerid == ident) && (s->writeperm & perm)) {
 			result = 1;
-			ast_mutex_unlock(&s->__lock);
+			ao2_unlock(s);
+			unref_mansession(s);
 			break;
 		}
-		ast_mutex_unlock(&s->__lock);
+		ao2_unlock(s);
+		unref_mansession(s);
 	}
-	AST_LIST_UNLOCK(&sessions);
 	return result;
 }
 
@@ -3475,8 +3681,9 @@
 			ast_str_append(out, 0, "%s", buf);
 			dst = buf;
 			space = sizeof(buf);
-			if (*src == '\0')
+			if (*src == '\0') {
 				break;
+			}
 		}
 			
 		if ( (mode & 2) && !isalnum(*src)) {
@@ -3523,29 +3730,11 @@
 	int count;
 };
 
-static int compress_char(char c)
-{
-	c &= 0x7f;
-	if (c < 32)
-		return 0;
-	else if (c >= 'a' && c <= 'z')
-		return c - 64;
-	else if (c > 'z')
-		return '_';
-	else
-		return c - 32;
-}
-
 static int variable_count_hash_fn(const void *vvc, const int flags)
 {
 	const struct variable_count *vc = vvc;
-	int res = 0, i;
-	for (i = 0; i < 5; i++) {
-		if (vc->varname[i] == '\0')
-			break;
-		res += compress_char(vc->varname[i]) << (i * 6);
-	}
-	return res;
+
+	return ast_str_hash(vc->varname);
 }
 
 static int variable_count_cmp_fn(void *obj, void *vstr, int flags)
@@ -3587,7 +3776,7 @@
  *   Sections (blank lines in the input) are separated by a <HR>
  *
  */
-static void xml_translate(struct ast_str **out, char *in, struct ast_variable *vars, enum output_format format)
+static void xml_translate(struct ast_str **out, char *in, struct ast_variable *get_vars, enum output_format format)
 {
 	struct ast_variable *v;
 	const char *dest = NULL;
@@ -3599,30 +3788,41 @@
 	struct variable_count *vc = NULL;
 	struct ao2_container *vco = NULL;
 
-	for (v = vars; v; v = v->next) {
-		if (!dest && !strcasecmp(v->name, "ajaxdest"))
-			dest = v->value;
-		else if (!objtype && !strcasecmp(v->name, "ajaxobjtype"))
-			objtype = v->value;
+	if (xml) {
+		/* dest and objtype need only for XML format */
+		for (v = get_vars; v; v = v->next) {
+			if (!strcasecmp(v->name, "ajaxdest")) {
+				dest = v->value;
+			} else if (!strcasecmp(v->name, "ajaxobjtype")) {
+				objtype = v->value;
+			}
+		}
+		if (ast_strlen_zero(dest)) {
+			dest = "unknown";
+		}
+		if (ast_strlen_zero(objtype)) {
+			objtype = "generic";
+		}
 	}
-	if (!dest)
-		dest = "unknown";
-	if (!objtype)
-		objtype = "generic";
-
+	
 	/* we want to stop when we find an empty line */
 	while (in && *in) {
 		val = strsep(&in, "\r\n");	/* mark start and end of line */
-		if (in && *in == '\n')		/* remove trailing \n if any */
+		if (in && *in == '\n') {	/* remove trailing \n if any */
 			in++;
+		}
 		ast_trim_blanks(val);
 		ast_debug(5, "inobj %d in_data %d line <%s>\n", inobj, in_data, val);
-		if (ast_strlen_zero(val)) {
-			if (in_data) { /* close data */
+		if (ast_strlen_zero(val)) { 
+			/* empty line */
+			if (in_data) {
+				/* close data in Opaque mode */
 				ast_str_append(out, 0, xml ? "'" : "</td></tr>\n");
 				in_data = 0;
 			}
+			
 			if (inobj) {
+				/* close block */
 				ast_str_append(out, 0, xml ? " /></response>\n" :
 					"<tr><td colspan=\"2\"><hr></td></tr>\r\n");
 				inobj = 0;
@@ -3632,54 +3832,57 @@
 			continue;
 		}
 
-		/* we expect Name: value lines */
-		if (in_data) {
-			var = NULL;
-		} else {
-			var = strsep(&val, ":");
-			if (val) {	/* found the field name */
-				val = ast_skip_blanks(val);
-				ast_trim_blanks(var);
-			} else {		/* field name not found, move to opaque mode */
-				val = var;
-				var = "Opaque-data";
-			}
-		}
-
 		if (!inobj) {
-			if (xml)
+			/* start new block */
+			if (xml) {
 				ast_str_append(out, 0, "<response type='object' id='%s'><%s", dest, objtype);
-			else
-				ast_str_append(out, 0, "<body>\n");
+			}
 			vco = ao2_container_alloc(37, variable_count_hash_fn, variable_count_cmp_fn);
 			inobj = 1;
 		}
+		
+		if (in_data) {
+			/* Process data field in Opaque mode */
+			xml_copy_escape(out, val, 0);   /* data field */
+			ast_str_append(out, 0, xml ? "\n" : "<br>\n");
+			continue;
+		}
+			
+		/* We expect "Name: value" line here */
+		var = strsep(&val, ":");
+		if (val) {
+			/* found the field name */
+			val = ast_skip_blanks(val);
+			ast_trim_blanks(var);
+		} else {
+			/* field name not found, switch to opaque mode */
+			val = var;
+			var = "Opaque-data";
+			in_data = 1;
+		}
 
-		if (!in_data) {	/* build appropriate line start */
-			ast_str_append(out, 0, xml ? " " : "<tr><td>");
-			if ((vc = ao2_find(vco, var, 0)))
-				vc->count++;
-			else {
-				/* Create a new entry for this one */
-				vc = ao2_alloc(sizeof(*vc), NULL);
-				vc->varname = var;
-				vc->count = 1;
-				ao2_link(vco, vc);
-			}
-			xml_copy_escape(out, var, xml ? 1 | 2 : 0);
-			if (vc->count > 1)
-				ast_str_append(out, 0, "-%d", vc->count);
-			ao2_ref(vc, -1);
-			ast_str_append(out, 0, xml ? "='" : "</td><td>");
-			if (!strcmp(var, "Opaque-data"))
-				in_data = 1;
+
+		ast_str_append(out, 0, xml ? " " : "<tr><td>");
+		if ((vc = ao2_find(vco, var, 0))) {
+			vc->count++;
+		} else {
+			/* Create a new entry for this one */
+			vc = ao2_alloc(sizeof(*vc), NULL);
+			vc->varname = var;
+			vc->count = 1;
+			ao2_link(vco, vc);
 		}
+		
+		xml_copy_escape(out, var, xml ? 1 | 2 : 0); /* data name */
+		if (vc->count > 1) {
+			ast_str_append(out, 0, "-%d", vc->count);
+		}
+		ao2_ref(vc, -1);
+		ast_str_append(out, 0, xml ? "='" : "</td><td>");
 		xml_copy_escape(out, val, 0);	/* data field */
-		if (!in_data)
-			ast_str_append(out, 0, xml ? "'" : "</td></tr>\n");
-		else
-			ast_str_append(out, 0, xml ? "\n" : "<br>\n");
+		ast_str_append(out, 0, xml ? "'" : "</td></tr>\n");
 	}
+
 	if (inobj) {
 		ast_str_append(out, 0, xml ? " /></response>\n" :
 			"<tr><td colspan=\"2\"><hr></td></tr>\r\n");
@@ -3687,42 +3890,57 @@
 	}
 }
 
-static struct ast_str *generic_http_callback(enum output_format format,
-					     struct sockaddr_in *requestor, const char *uri, enum ast_http_method method,
-					     struct ast_variable *params, int *status,
-					     char **title, int *contentlength)
+static int generic_http_callback(struct ast_tcptls_session_instance *ser,
+					     enum ast_http_method method,
+					     enum output_format format,
+					     struct sockaddr_in *requestor, const char *uri,
+					     struct ast_variable *get_params,
+					     struct ast_variable *headers)
 {
 	struct mansession *s = NULL;
 	uint32_t ident = 0;
 	int blastaway = 0;
-	struct ast_variable *v;
+	struct ast_variable *v, *cookies, *params = get_params;
 	char template[] = "/tmp/ast-http-XXXXXX";	/* template for temporary file */
-	struct ast_str *out = NULL;
+	struct ast_str *http_header = NULL, *out = NULL;
 	struct message m = { 0 };
 	unsigned int x;
 	size_t hdrlen;
 
-	for (v = params; v; v = v->next) {
+	if (method != AST_HTTP_GET && method != AST_HTTP_HEAD && method != AST_HTTP_POST) {
+		ast_http_error(ser, 501, "Not Implemented", "Attempt to use unimplemented / unsupported method");
+		return -1;
+	}
+
+	cookies = ast_http_get_cookies(headers);
+	for (v = cookies; v; v = v->next) {
 		if (!strcasecmp(v->name, "mansession_id")) {
 			sscanf(v->value, "%x", &ident);
 			break;
 		}
 	}
+	if (cookies) {
+		ast_variables_destroy(cookies);
+	}
 
 	if (!(s = find_session(ident, 1))) {
+
+		if (num_sessions >= MAX_SESSIONS) {
+			/* Limit the active session numbers */
+			ast_http_error(ser, 500, "Server Error", "Internal Server Error (to many connections)\n");
+			return -1;
+		}
+		
+		/**/
 		/* Create new session.
 		 * While it is not in the list we don't need any locking
 		 */
-		if (!(s = ast_calloc(1, sizeof(*s)))) {
-			*status = 500;
-			goto generic_callback_out;
+		if (!(s = build_mansession(*requestor))) {
+			ast_http_error(ser, 500, "Server Error", "Internal Server Error (out of memory)\n");
+			return -1;
 		}
-		s->sin = *requestor;
-		s->fd = -1;
-		s->waiting_thread = AST_PTHREADT_NULL;
+		ao2_lock(s);
 		s->send_events = 0;
-		ast_mutex_init(&s->__lock);
-		ast_mutex_lock(&s->__lock);
 		s->inuse = 1;
 		/*!\note There is approximately a 1 in 1.8E19 chance that the following
 		 * calculation will produce 0, which is an invalid ID, but due to the
@@ -3732,23 +3950,34 @@
 		while ((s->managerid = rand() ^ (unsigned long) s) == 0);
 		s->last_ev = grab_last();
 		AST_LIST_HEAD_INIT_NOLOCK(&s->datastores);
-		AST_LIST_LOCK(&sessions);
-		AST_LIST_INSERT_HEAD(&sessions, s, list);
-		ast_atomic_fetchadd_int(&num_sessions, 1);
-		AST_LIST_UNLOCK(&sessions);
 	}
+	ao2_unlock(s);
 
-	ast_mutex_unlock(&s->__lock);
+	http_header = ast_str_create(128);
+	out = ast_str_create(2048);
 
-	if (!(out = ast_str_create(1024))) {
-		*status = 500;
+	if (http_header == NULL || out == NULL) {
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (ast_str_create() out of memory)\n");
 		goto generic_callback_out;
 	}
 
 	s->fd = mkstemp(template);	/* create a temporary file for command output */
 	unlink(template);
+	if(s->fd <= -1) {
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (mkstemp failed)\n");
+		goto generic_callback_out;
+	}
 	s->f = fdopen(s->fd, "w+");
+	if(!s->f) {
+		ast_log(LOG_WARNING, "HTTP Manager, fdopen failed: %s!\n", strerror(errno));
+		ast_http_error(ser, 500, "Server Error", "Internal Server Error (fdopen failed)\n");
+		goto generic_callback_out;
+	}
 
+	if (method == AST_HTTP_POST) {
+		params = get_post_vars(ser, headers);
+	}
+
 	for (x = 0, v = params; v && (x < AST_MAX_MANHEADERS); x++, v = v->next) {
 		hdrlen = strlen(v->name) + strlen(v->value) + 3;
 		m.headers[m.hdrcount] = alloca(hdrlen);
@@ -3772,13 +4001,12 @@
 		s->needdestroy = 1;
 	}
 
-	ast_str_append(&out, 0,
-		       "Content-type: text/%s\r\n"
-		       "Cache-Control: no-cache;\r\n"
-		       "Set-Cookie: mansession_id=\"%08x\"; Version=\"1\"; Max-Age=%d\r\n"
-		       "\r\n",
-			contenttype[format],
-			s->managerid, httptimeout);
+	ast_str_append(&http_header, 0,
+	       "Content-type: text/%s\r\n"
+	       "Cache-Control: no-cache;\r\n"
+	       "Set-Cookie: mansession_id=\"%08x\"; Version=\"1\"; Max-Age=%d",
+		contenttype[format],
+		s->managerid, httptimeout);
 
 	if (format == FORMAT_XML) {
 		ast_str_append(&out, 0, "<ajax-response>\n");
@@ -3791,7 +4019,7 @@
 
 #define ROW_FMT	"<tr><td colspan=\"2\" bgcolor=\"#f1f1ff\">%s</td></tr>\r\n"
 #define TEST_STRING \
-	"<form action=\"manager\">\n\
+	"<form action=\"manager\" method=\"post\">\n\
 	Action: <select name=\"action\">\n\
 		<option value=\"\">-----&gt;</option>\n\
 		<option value=\"login\">login</option>\n\
@@ -3816,10 +4044,11 @@
 		
 		if (l) {
 			if ((buf = mmap(NULL, l, PROT_READ | PROT_WRITE, MAP_SHARED, s->fd, 0))) {
-				if (format == FORMAT_XML || format == FORMAT_HTML)
+				if (format == FORMAT_XML || format == FORMAT_HTML) {
 					xml_translate(&out, buf, params, format);
-				else
+				} else {
 					ast_str_append(&out, 0, "%s", buf);
+				}
 				munmap(buf, l);
 			}
 		} else if (format == FORMAT_XML || format == FORMAT_HTML) {
@@ -3832,10 +4061,11 @@
 
 	if (format == FORMAT_XML) {
 		ast_str_append(&out, 0, "</ajax-response>\n");
-	} else if (format == FORMAT_HTML)
+	} else if (format == FORMAT_HTML) {
 		ast_str_append(&out, 0, "</table></body>\r\n");
+	}
 
-	ast_mutex_lock(&s->__lock);
+	ao2_lock(s);
 	/* Reset HTTP timeout.  If we're not authenticated, keep it extremely short */
 	s->sessiontimeout = time(NULL) + ((s->authenticated || httptimeout < 5) ? httptimeout : 5);
 
